/*
 * _lowlevel_set_fp_and_sp.h
 *
 *  Created on: 17 march 2020
 *      Author: Sukhanov Mikhail (suhanov@niiet.ru)
 */

#ifndef   OCRAM_START
  #define OCRAM_START  0xA0000000
#endif

#ifndef   OCRAM_SIZE
  #define OCRAM_SIZE   0x00010000
#endif

#define _FRAME_POINTER (OCRAM_START + OCRAM_SIZE - 0x20)

// Maximum expected stack size:
#ifndef   _STACK_SIZE
  #define _STACK_SIZE  0x00001000
//                     0x00000800 -  2 KByte
//                     0x00001000 -  4 KByte
//                     0x00002000 -  8 KByte
//                     0x00004000 - 16 KByte
#endif

static inline void _lowlevel_set_fp_and_sp() __attribute__((always_inline));
static inline void _lowlevel_set_fp_and_sp() {
	asm volatile (
		"set %0, %%fp;"
		"sub %%fp, 0x60, %%sp;"
		:
		: "i" (_FRAME_POINTER)
	);

  // If memory area have Hamming(39, 32) error code protection then
  // access to uninitialize word (32-bit) will produce trap to each 8-, 16-bit.
  // Clearing of expected stack memory space (guard from 'stb/sth %rd, [%fp + %rs2/imm13]'
  // and 'ldb/ldh [%fp + %rs2/imm13], %rd' accesses):
	unsigned int temp_register;
	asm volatile (
		"  set %1, %0;"
		"  sub %%fp, %0, %0;"
		"  clr %%g1;"
		"1:;"
		"  std %%g0, [%0];"
		"  subcc %%fp, %0, %%g0;"
		"  bg 1b;"
		"   add %0, 8, %0;"
		: "=r" (temp_register)
		: "i" (_STACK_SIZE)
		: "g1"
	);

  
}
